/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfrom.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_dns.m4"
/* This file is part of mailfrom filter.             -*- c -*-
   Copyright (C) 2006 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

void
#line 24
bi_hostname(eval_environ_t env)
#line 24 "bi_dns.m4"
{
#line 24
	
#line 24
char * string = (char *) get_arg(env, 0);
#line 24
        
#line 24
        adjust_stack(env, 1);
#line 24

#line 24
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 24
		prog_trace(env, "hostname %s",string);;
#line 24

{
	char *s = env_dict_getsym(env, string);
	if (!s) {
		char hbuf[NI_MAXHOST];
		if (resolve_ipstr(string, hbuf, sizeof(hbuf)))
			hbuf[0] = 0;
		s = env_dict_install(env, string, hbuf);
	}
	if (s[0] == 0)
		s = string;
	do {
#line 35
push(env, (STKVAL) (s));
#line 35
return;
#line 35
} while (0);	
}
}

void
#line 39
bi_resolve(eval_environ_t env)
#line 39 "bi_dns.m4"
{
#line 39
	
#line 39
char * string = (char *) get_arg(env, 0);
#line 39
        
#line 39
        adjust_stack(env, 1);
#line 39

#line 39
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 39
		prog_trace(env, "resolve %s",string);;
#line 39

{
	char *s;
	struct hostent *host;
	
	s = env_dict_getsym(env, string);
	if (!s) {
		host = gethostbyname(string);
		if (!host)
			s = "0";
		else if (host->h_length == 4) {
			struct in_addr addr;
			addr.s_addr = *(unsigned long*)host->h_addr;
			s = inet_ntoa(addr);
		} else
			s = "resolved";
		s = env_dict_install(env, string, s);
	}
	do {
#line 57
push(env, (STKVAL) (s));
#line 57
return;
#line 57
} while (0);	
}
}

void
#line 61
bi_hasmx(eval_environ_t env)
#line 61 "bi_dns.m4"
{
#line 61
	
#line 61
char * string = (char *) get_arg(env, 0);
#line 61
        
#line 61
        adjust_stack(env, 1);
#line 61

#line 61
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 61
		prog_trace(env, "hasmx %s",string);;
#line 61

{
	mxbuf_t mxbuf;
	mf_status mxstat;

	mxstat = getmx(string, mxbuf);
	
	if (mxstat != mf_success) {
		if (env_catch(env, mxstat) == 0)
			return;
	} else
		freemx(mxbuf);

	do {
#line 74
push(env, (STKVAL) (mxstat == mf_success));
#line 74
return;
#line 74
} while (0);
}
}

static int
resolve_host(const char *string, unsigned long *ip)
{
	struct hostent *host = gethostbyname(string);
	if (!host)
		return 1;
	else if (host->h_length == 4) {
		*ip = *(unsigned long*)host->h_addr;
		return 0;
	}
	return 1;
}

void
#line 91
bi_ismx(eval_environ_t env)
#line 91 "bi_dns.m4"
{
#line 91
	
#line 91
char * domain = (char *) get_arg(env, 1);
#line 91
        char * ipstr = (char *) get_arg(env, 0);
#line 91
        
#line 91
        adjust_stack(env, 2);
#line 91

#line 91
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 91
		prog_trace(env, "ismx %s %s",domain, ipstr);;
#line 91

{
	mxbuf_t mxbuf;
	mf_status mxstat;
	unsigned long ip;
	int rc = 0;
	
		if (!(resolve_host(ipstr, &ip) == 0))
			do {
#line 99
		if (env_catch(env, mf_resolve) == 0)
#line 99
			return ;
#line 99
		else
#line 99
			runtime_error(env,
#line 99
				                                                  "ismx: " "cannot resolve host name %s",ipstr);
#line 99
	} while (0) 
#line 99
;
#line 99
;
	
	mxstat = getmx(domain, mxbuf);
	
	if (mxstat != mf_success) {
		if (env_catch(env, mxstat) == 0)
			return;
	} else {
		int i;

		for (i = 0; i < MAXMXCOUNT && mxbuf[i]; i++) {
			unsigned long n;
			
			if (!resolve_host(mxbuf[i], &n) && n == ip) {
				rc = 1;
				break;
			}
		}
		freemx(mxbuf);
	}
	do {
#line 119
push(env, (STKVAL) (rc));
#line 119
return;
#line 119
} while (0);
}
}

void
#line 123
bi_relayed(eval_environ_t env)
#line 123 "bi_dns.m4"
{
#line 123
	
#line 123
char * s = (char *) get_arg(env, 0);
#line 123
        
#line 123
        adjust_stack(env, 1);
#line 123

#line 123
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 123
		prog_trace(env, "relayed %s",s);;
#line 123

{
	do {
#line 125
push(env, (STKVAL) (relayed_domain_p(s)));
#line 125
return;
#line 125
} while (0);
}
}

void
#line 129
bi_listens(eval_environ_t env)
#line 129 "bi_dns.m4"
{
#line 129
	
#line 129
char * s = (char *) get_arg(env, 0);
#line 129
        
#line 129
        adjust_stack(env, 1);
#line 129

#line 129
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 129
		prog_trace(env, "listens %s",s);;
#line 129

{
	do {
#line 131
push(env, (STKVAL) (listens_on (s, 25) == mf_success));
#line 131
return;
#line 131
} while (0);
}
}

void
#line 135
bi_match_cidr(eval_environ_t env)
#line 135 "bi_dns.m4"
{
#line 135
	
#line 135
char * ipstr = (char *) get_arg(env, 1);
#line 135
        char * cidrstr = (char *) get_arg(env, 0);
#line 135
        
#line 135
        adjust_stack(env, 2);
#line 135

#line 135
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 135
		prog_trace(env, "match_cidr %s %s",ipstr, cidrstr);;
#line 135

{
	char *p;
	struct in_addr addr, cidr;
	char netbuf[16], *netstr;
	unsigned long netmask;
	int result = 0;
	const struct locus *locus = env_get_locus(env);
	
	do {
			if (!(inet_aton(ipstr, &addr)))
#line 148
			do {
#line 148
		if (env_catch(env, mf_invip) == 0)
#line 148
			return ;
#line 148
		else
#line 148
			runtime_error(env,
#line 148
				                                                  "match_cidr: " "invalid IP address (%s)",ipstr);
#line 148
	} while (0) 
#line 148
;
#line 148
;
		p = strchr(cidrstr, '/');
		if (!p) {
			netstr = cidrstr;
			netmask = 0xfffffffful;
		} else {
			size_t len = p - cidrstr;
			unsigned long n;
			
				if (!(len < sizeof netbuf))
#line 159
			do {
#line 159
		if (env_catch(env, mf_invcidr) == 0)
#line 159
			return ;
#line 159
		else
#line 159
			runtime_error(env,
#line 159
				                                                  "match_cidr: " "invalid CIDR (%s)",cidrstr);
#line 159
	} while (0) 
#line 159
;
#line 159
;
			memcpy(netbuf, cidrstr, len);
			netbuf[len] = 0;
			netstr = netbuf;
			n = strtoul(p + 1, &p, 10);
				if (!(*p == 0 && n <= 32))
			do {
#line 165
		if (env_catch(env, mf_invcidr) == 0)
#line 165
			return ;
#line 165
		else
#line 165
			runtime_error(env,
#line 165
				                                                  "match_cidr: " "invalid CIDR (netmask of %s)",cidrstr);
#line 165
	} while (0) 
#line 165
;
#line 165
;
			n = 32 - n;
			if (n == 32)
				netmask = 0;
			else
				netmask = (0xfffffffful >> n) << n;
		}
			if (!(inet_aton(netstr, &cidr)))
#line 174
			do {
#line 174
		if (env_catch(env, mf_invcidr) == 0)
#line 174
			return ;
#line 174
		else
#line 174
			runtime_error(env,
#line 174
				                                                  "match_cidr: " "invalid CIDR (network part of %s)",cidrstr);
#line 174
	} while (0) 
#line 174
;
#line 174
;

		addr.s_addr = ntohl(addr.s_addr);
		cidr.s_addr = ntohl(cidr.s_addr);
		debug5(100, "%s:%lu: addr=%lx net=%lx mask=%lx" ,
		       locus->file, locus->line,
		       addr.s_addr, cidr.s_addr, netmask);
		result = (addr.s_addr & netmask) == cidr.s_addr;
	} while (0);
	do {
#line 183
push(env, (STKVAL) (result));
#line 183
return;
#line 183
} while (0);
}
}

void
#line 187
bi_domainpart(eval_environ_t env)
#line 187 "bi_dns.m4"
{
#line 187
	
#line 187
char * str = (char *) get_arg(env, 0);
#line 187
        
#line 187
        adjust_stack(env, 1);
#line 187

#line 187
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 187
		prog_trace(env, "domainpart %s",str);;
#line 187

{
	char *p = strchr(str, '@');
	do {
#line 190
push(env, (STKVAL) (p ? p+1 : str));
#line 190
return;
#line 190
} while (0);
}
}

void
#line 194
bi_localpart(eval_environ_t env)
#line 194 "bi_dns.m4"
{
#line 194
	
#line 194
char * str = (char *) get_arg(env, 0);
#line 194
        
#line 194
        adjust_stack(env, 1);
#line 194

#line 194
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 194
		prog_trace(env, "localpart %s",str);;
#line 194

{
	char *p = strchr(str, '@');

	if (p) {
		size_t size = p - str;
		char *string_space = heap_reserve(env, size + 1);
		memcpy(string_space, str, size);
		string_space[size] = 0;
		do {
#line 203
push(env, (STKVAL) (string_space));
#line 203
return;
#line 203
} while (0);
	} else
		do {pushs(env, str);
#line 205
return;
#line 205
} while (0);
}
}


#line 209
void
#line 209
dns_init_builtin()
#line 209
{
#line 209
	#line 24 "bi_dns.m4"
va_builtin_install_ex("hostname", bi_hostname, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 39 "bi_dns.m4"
va_builtin_install_ex("resolve", bi_resolve, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 61 "bi_dns.m4"
va_builtin_install_ex("hasmx", bi_hasmx, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 91 "bi_dns.m4"
va_builtin_install_ex("ismx", bi_ismx, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_string);
#line 123 "bi_dns.m4"
va_builtin_install_ex("relayed", bi_relayed, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 129 "bi_dns.m4"
va_builtin_install_ex("listens", bi_listens, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 135 "bi_dns.m4"
va_builtin_install_ex("match_cidr", bi_match_cidr, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_string);
#line 187 "bi_dns.m4"
va_builtin_install_ex("domainpart", bi_domainpart, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 194 "bi_dns.m4"
va_builtin_install_ex("localpart", bi_localpart, 0, 0, dtype_string,  1, 0,  dtype_string);

#line 209 "bi_dns.m4"
		
#line 209
}
#line 0

#line 0

