/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfrom.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_other.m4"
/* This file is part of mailfrom filter.             -*- c -*-
   Copyright (C) 2006 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

static int
valid_user_p(eval_environ_t env, const char *name)
{
	int rc;
	struct mu_auth_data *auth_data = NULL;

#if HAVE_MU_GET_AUTH
	rc = mu_get_auth(&auth_data, mu_auth_key_name, name);
	mu_auth_data_free(auth_data);
	switch (rc) {
	case 0:
		rc = 1;
		break;
		
	case MU_ERR_AUTH_FAILURE:
		rc = 0;
		break;

	case EAGAIN:
                	do {
#line 40
		if (env_catch(env, mf_temp_failure) == 0)
#line 40
			return 1;
#line 40
		else
#line 40
			runtime_error(env,
#line 40
				       "Temporary failure querying for username %s",name);
#line 40
	} while (0) 
#line 40
;
		break;

	default:
                	do {
#line 46
		if (env_catch(env, mf_failure) == 0)
#line 46
			return 1;
#line 46
		else
#line 46
			runtime_error(env,
#line 46
				       "Failure querying for username %s",name);
#line 46
	} while (0) 
#line 46
;
		break;
	}
#else
	auth_data = mu_get_auth_by_name(name);
	rc = auth_data != NULL;
	mu_auth_data_free(auth_data);
#endif
	debug2(10, "Checking user %s: %s", name,
	       rc ? "true" : "false");
	return rc;
}

void
#line 59
bi_validuser(eval_environ_t env)
#line 59 "bi_other.m4"
{
#line 59
	
#line 59
char * name = (char *) get_arg(env, 0);
#line 59
        
#line 59
        adjust_stack(env, 1);
#line 59

#line 59
	if (prog_trace_option & BUILTIN_MASK_other)
#line 59
		prog_trace(env, "validuser %s",name);;
#line 59

{
	do {
#line 61
push(env, (STKVAL) (valid_user_p(env, name)));
#line 61
return;
#line 61
} while (0);
}
}

void
#line 65
bi_interval(eval_environ_t env)
#line 65 "bi_other.m4"
{
#line 65
	
#line 65
char * str = (char *) get_arg(env, 0);
#line 65
        
#line 65
        adjust_stack(env, 1);
#line 65

#line 65
	if (prog_trace_option & BUILTIN_MASK_other)
#line 65
		prog_trace(env, "interval %s",str);;
#line 65

{
       time_t t;
       char *endp;

       	if (!(parse_time_interval(str, &t, &endp) == 0))
#line 72
			do {
#line 72
		if (env_catch(env, mf_invtime) == 0)
#line 72
			return ;
#line 72
		else
#line 72
			runtime_error(env,
#line 72
				                                                  "interval: " "unrecognized time  (near `%s')",endp);
#line 72
	} while (0) 
#line 72
;
#line 72
;
       do {
#line 73
push(env, (STKVAL) (t));
#line 73
return;
#line 73
} while (0);
}
}

void
#line 77
bi_rate(eval_environ_t env)
#line 77 "bi_other.m4"
{
#line 77
	
#line 77
char * key = (char *) get_arg(env, 1);
#line 77
        long  interval = (long ) get_arg(env, 0);
#line 77
        
#line 77
        adjust_stack(env, 2);
#line 77

#line 77
	if (prog_trace_option & BUILTIN_MASK_other)
#line 77
		prog_trace(env, "rate %s %lu",key, interval);;
#line 77

{
	double rate;
	long lrate;
		
		if (!(get_rate(key, &rate) == mf_success))
#line 84
			do {
#line 84
		if (env_catch(env, mf_dbfailure) == 0)
#line 84
			return ;
#line 84
		else
#line 84
			runtime_error(env,
#line 84
				                                                  "rate: " "cannot get rate for %s",key);
#line 84
	} while (0) 
#line 84
;
#line 84
;
	lrate = rate * interval;
	
	do {
#line 87
push(env, (STKVAL) (lrate));
#line 87
return;
#line 87
} while (0);
}
}

void
#line 91
bi_debug(eval_environ_t env)
#line 91 "bi_other.m4"
{
#line 91
	
#line 91
char * spec = (char *) get_arg(env, 0);
#line 91
        
#line 91
        adjust_stack(env, 1);
#line 91

#line 91
	if (prog_trace_option & BUILTIN_MASK_other)
#line 91
		prog_trace(env, "debug %s",spec);;
#line 91

{
	enable_debug_list(spec);
}
}

void
#line 97
bi_cancel_debug(eval_environ_t env)
#line 97 "bi_other.m4"
{
#line 97
	
#line 97
char * spec = (char *) get_arg(env, 0);
#line 97
        
#line 97
        adjust_stack(env, 1);
#line 97

#line 97
	if (prog_trace_option & BUILTIN_MASK_other)
#line 97
		prog_trace(env, "cancel_debug %s",spec);;
#line 97

{
	disable_debug_list(spec);
}
}

void
#line 103
bi_program_trace(eval_environ_t env)
#line 103 "bi_other.m4"
{
#line 103
	
#line 103
char * name = (char *) get_arg(env, 0);
#line 103
        
#line 103
        adjust_stack(env, 1);
#line 103

#line 103
	if (prog_trace_option & BUILTIN_MASK_other)
#line 103
		prog_trace(env, "program_trace %s",name);;
#line 103

{
	enable_prog_trace(name);
}
}

void
#line 109
bi_cancel_program_trace(eval_environ_t env)
#line 109 "bi_other.m4"
{
#line 109
	
#line 109
char * name = (char *) get_arg(env, 0);
#line 109
        
#line 109
        adjust_stack(env, 1);
#line 109

#line 109
	if (prog_trace_option & BUILTIN_MASK_other)
#line 109
		prog_trace(env, "cancel_program_trace %s",name);;
#line 109

{
	disable_prog_trace(name);
}
}	


#line 115
void
#line 115
other_init_builtin()
#line 115
{
#line 115
	#line 59 "bi_other.m4"
va_builtin_install_ex("validuser", bi_validuser, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 65 "bi_other.m4"
va_builtin_install_ex("interval", bi_interval, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 77 "bi_other.m4"
va_builtin_install_ex("rate", bi_rate, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_number);
#line 91 "bi_other.m4"
va_builtin_install_ex("debug", bi_debug, 0, 0, dtype_unspecified,  1, 0,  dtype_string);
#line 97 "bi_other.m4"
va_builtin_install_ex("cancel_debug", bi_cancel_debug, 0, 0, dtype_unspecified,  1, 0,  dtype_string);
#line 103 "bi_other.m4"
va_builtin_install_ex("program_trace", bi_program_trace, 0, 0, dtype_unspecified,  1, 0,  dtype_string);
#line 109 "bi_other.m4"
va_builtin_install_ex("cancel_program_trace", bi_cancel_program_trace, 0, 0, dtype_unspecified,  1, 0,  dtype_string);

#line 115 "bi_other.m4"
		
#line 115
}
#line 0

#line 0

